# dbt-common Changelog

- This file provides a full account of all changes to `dbt-common`
- Changes are listed under the (pre)release in which they first appear. Subsequent releases include changes from previous releases.
- "Breaking changes" listed under a version may require action from end users or external maintainers when upgrading to that version.
- Do not edit this file directly. This file is auto-generated using [changie](https://github.com/miniscruff/changie). For details on how to document a change, see [the contributing guide](https://github.com/dbt-labs/dbt-common/blob/main/CONTRIBUTING.md#adding-changelog-entry)

## dbt-common 1.7.0 - July 30, 2024

### Under the Hood

- Add record grouping mechanism to record/replay. ([#169](https://github.com/dbt-labs/dbt-common/issues/169))

## dbt-common 1.6.0 - July 2, 2024

### Features

- Add to and to_columns to ColumnLevelConstraint and ModelLevelConstraint contracts ([#168](https://github.com/dbt-labs/dbt-common/issues/168))

### Fixes

- Fix case-insensitive env vars for Windows ([#166](https://github.com/dbt-labs/dbt-common/issues/166))

## dbt-common 1.4.0 - June 18, 2024

### Under the Hood

- Add support for basic diff of run recordings. ([#144](https://github.com/dbt-labs/dbt-common/issues/144))
- Deserialize Record objects on a just-in-time basis. ([#151](https://github.com/dbt-labs/dbt-common/issues/151))

## dbt-common 1.3.0 - June 5, 2024

### Under the Hood

- Move CatalogKey, ColumnMetadata, ColumnMap, CatalogTable to dbt-common ([#147](https://github.com/dbt-labs/dbt-common/issues/147))

## dbt-common 1.2.0 - May 29, 2024

### Under the Hood

- Allow dynamic selection of record types when recording. ([#140](https://github.com/dbt-labs/dbt-common/issues/140))
- Move StatsItem, StatsDict, TableMetadata to dbt-common ([#141](https://github.com/dbt-labs/dbt-common/issues/141))

## dbt-common 1.1.0 - May 21, 2024

### Features

- Support adding callbacks to the event manager ([#131](https://github.com/dbt-labs/dbt-common/issues/131))
- Add a print event to support firing event to console in --quiet mode ([#8756](https://github.com/dbt-labs/dbt-common/issues/8756))

## dbt-common 1.0.4 - May 7, 2024

### Features

- Enable serialization contexts ([#126](https://github.com/dbt-labs/dbt-common/issues/126))

## dbt-common 1.0.3 - May 1, 2024

### Dependencies

- Pin agate `>=1.7.0,<1.10` ([#119](https://github.com/dbt-labs/dbt-common/pull/119))
- update pathspec upper version limitation ([#120](https://github.com/dbt-labs/dbt-common/pull/120))

## dbt-common 1.0.2 - April 24, 2024

### Features

- Add ability to silence warnings via `WarnErrorOptions` ([#111](https://github.com/dbt-labs/dbt-common/issues/111))

### Under the Hood

- Remove the final underscore from secret and private environment variable constants. ([#109](https://github.com/dbt-labs/dbt-common/issues/109))

## dbt-common 1.0.1 - April 12, 2024

### Features

- Support environment variables which dbt can see but user code cannot. ([#103](https://github.com/dbt-labs/dbt-common/issues/103))
- Add `error_tag` util to the `ui` module ([#107](https://github.com/dbt-labs/dbt-common/issues/107))

## dbt-common 1.0.0 - April 1, 2024

### Under the Hood

- Implement record/replay mechanism ([#9689](https://github.com/dbt-labs/dbt-common/issues/9689))
- Stream JSON on read/write instead of holding it in memory ([#96](https://github.com/dbt-labs/dbt-common/issues/96))
- Improve startup performance by lazy-compiling mashumaro serialization functions ([#97](https://github.com/dbt-labs/dbt-common/issues/97))

## dbt-common 0.1.6 - February 22, 2024

### Fixes

- Fix the unset_contextvars function in events/contextvars.py ([#82](https://github.com/dbt-labs/dbt-common/issues/82))

### Under the Hood

- Restrict protobuf library to major version 4. ([#9566](https://github.com/dbt-labs/dbt-common/issues/9566))

## dbt-common 0.1.65- February 8, 2024

### Under the Hood

- Add Invocation Context Support to MultiThreadedExecutor ([#75](https://github.com/dbt-labs/dbt-common/issues/75))

## dbt-common 0.1.4 - February 7, 2024

### Fixes

- Make invocation contexts more reliable in testing scenarios. ([#52](https://github.com/dbt-labs/dbt-common/issues/52))

### Under the Hood

- Remove `fire_event_if_test` method ([#66](https://github.com/dbt-labs/dbt-common/issues/66))

## dbt-common 0.1.3 - February 1, 2024

### Features

- Cache static objects between tests to accelerate integration runs. ([#55](https://github.com/dbt-labs/dbt-common/issues/55))
- Added a new InvocationContext class for application context management. ([#57](https://github.com/dbt-labs/dbt-common/issues/57))
- Add dataclass utility `Mergeable` ([#58](https://github.com/dbt-labs/dbt-common/issues/58))

## dbt-common 0.1.1 - January 26, 2024

### Under the Hood

- Clean up macro contexts. ([#35](https://github.com/dbt-labs/dbt-common/issues/35))
- Change metadata_vars \`if not\` to \`if ... is None\` ([#6073](https://github.com/dbt-labs/dbt-common/issues/6073))
- Inject TagIterator into BlockIterator for greater flexibility. ([#38](https://github.com/dbt-labs/dbt-common/issues/38))

### Contributors
- [@truls-p](https://github.com/truls-p) ([#6073](https://github.com/dbt-labs/dbt-common/issues/6073))
